# coding:utf-8
# tabulation.rb
# 内容 :　クラス別科目別成績データ集計
# Copyright (c) 2002-2015 Mitsuo Minagawa, All rights reserved.
# (minagawa@fb3.so-net.ne.jp)
# 使用方法 : c:\>ruby tabulation.rb
#

# 入力ファイル
in1_file	=	open("input.txt","r:shift_jis:utf-8")
# 出力ファイル
out1_file	=	open("total.txt","w:shift_jis:utf-8")
#
# 入力データ:以下の5項目
#
#　クラス,出席番号,氏名,科目コード,点数
#   
# 集計用データ:
#                   $sum[0-3][0-4][0-3]
#                       1次元目=>１組:1、２組:2、３組:3、合計:4の4項目  
#                       2次元目=>国語から社会までの5科目   
#                               国語:01、算数:02、理科:03、社会:04、英語:05
#                       3次元目=>生徒数、最高点、最低点、平均点の4項目

#   
# 3次元テーブルを作成する。
#   
def	threeDarray(i,j,k)
	(0...i).map	{
		(0...j).map	{ Array.new(k) }
			}
end	

sum	=	threeDarray(4,5,4)
#   
# 出力用の1次元テーブルを作成する。
#   
out1_array	=	Array.new()

# 最低点の初期値として、100点を設定する。
# それ以外は、0クリアする。
for	i	in	0..3	
	for	j	in	0..4	
		for	k	in	0..3	
			if	k	==	2
				sum[i][j][k]	=	100	#最低点の初期値
			else	
				sum[i][j][k]	=	0	
			end	
		end	
	end	
end	

#   
# メイン処理 
#   
while	(line1	=	in1_file.gets)
	line1.chomp!
	in1	=	line1.split("\t",-1)
#   
# クラスの振り分け
#   
	case	in1[0]
		when	"1"			#"1"は１組
			i	=	0
		when	"2"			#"2"は２組
			i	=	1
		when	"3"			#"3"は３組
			i	=	2
	end	
#   
# 科目の振り分け 
#   
	case	in1[3]	
		when	"01"	#国語
			j	=	0
		when	"02"	#算数
			j	=	1
		when	"03"	#理科
			j	=	2
		when	"04"	#社会
			j	=	3
		when	"05"	#英語
			j	=	4
	end	
#   
#   
# 生徒数
#   
	sum[i][j][0]	+=	1		#クラス別の生徒数
	sum[3][j][0]	+=	1		#全クラスの生徒数
#   
# 最高点(初期値:0)
#   
	if		(sum[i][j][1]		<	in1[4].to_i)	
			sum[i][j][1]		=	in1[4].to_i		#クラス別科目別の最高点
	end	
	if		(sum[3][j][1]	<	in1[4].to_i)	
			sum[3][j][1]		=	in1[4].to_i		#全クラスの科目別の最高点
	end	
#   
# 最低点(初期値:100)
#   
	if		(sum[i][j][2]		>	in1[4].to_i)	
			sum[i][j][2]		=	in1[4].to_i		#クラス別科目別の最低点
	end	
	if		(sum[3][j][2]	>	in1[4].to_i)	
			sum[3][j][2]		=	in1[4].to_i		#全クラスの科目別の最低点
	end	
#   
# 平均点(初期値:0)(最後に受験者数で割る)
#   
	sum[i][j][3]	+=	in1[4].to_i			#クラス別科目別の合計点
	sum[3][j][3]	+=	in1[4].to_i			#全クラスの科目別の合計点
end	
#   
# 平均点算出 
#   
for	i	in	0..3	
	for	j	in	0..4	
#   
#   クラス別科目別で生徒数がゼロなら、最高点と最低点、平均点をブランクにする。
#   それ以外は、クラス別科目別の平均点を算出する。
#   
		if		(sum[i][j][0]		==	0)	
				sum[i][j][1]		=	""			#クラス別科目別の最高点
				sum[i][j][2]		=	""			#クラス別科目別の最低点
				sum[i][j][3]		=	""			#クラス別科目別の平均点
		else	
				sum[i][j][3]		=	sprintf("%5.2f",(sum[i][j][3].to_f	/	sum[i][j][0].to_f))
		end	
	end	
end	
#   
# 成績データ出力
# 各列の項目
out1_title	=	["項目","国語","算数","理科","社会","英語"]
#   
# 各行の項目   
out1_item	=	["生徒数","最高点","最低点","平均点"]
#   

for	i	in	0..3	
	for	k	in	0..3	
		if			(k		==	0)
			if		(i		==	0)
					out1_file.print "１組","\n"
			elsif	(i		==	1)
					out1_file.print "２組","\n"
			elsif	(i		==	2)
					out1_file.print "３組","\n"
			elsif	(i		==	3)
					out1_file.print "総合計","\n"
			end	
					out1_file.print out1_title.join("\t"),"\n"	#クラス名等出力
		end	
		out1_array	=	[]
		out1_array.push(out1_item[k])				#各行の項目名セット

		for	j	in	0..4	
				out1_array.push(sum[i][j][k])		#各行の値セット
		end	
		out1	=	out1_array.join("\t")
		out1_file.print out1,"\n"
	end	
end	

# ファイルのクローズ
in1_file.close
out1_file.close
